using System;
using System.Drawing.Drawing2D;
using System.Drawing;
using System.Windows.Forms;

/*
 * Code from:
 * http://www.codeproject.com/cs/miscctrl/GradientPanelPackage.asp
 * http://www.codeproject.com/cs/miscctrl/gradientlabel.asp
 */

namespace Panes {

	internal class gradientLabel : System.Windows.Forms.Label {
		// declare two color for linear gradient
		private Color Color1 = Color.Black;
		private Color Color2 = Color.Black;

		// property of begin color in linear gradient
		public Color BeginColor {
			get {
				return Color1;
			}
			set {
				Color1 = value;
			}
		}
		// property of end color in linear gradient
		public Color EndColor {
			get {
				return Color2;
			}
			set {
				Color2 = value;
			}
		}

		public gradientLabel() {
			// Default get system color 
		}

		protected override void OnPaint(System.Windows.Forms.PaintEventArgs e) {

			// declare linear gradient brush for fill background of label
			LinearGradientBrush GBrush = new LinearGradientBrush(
				new Point(0, 0),
				new Point(0, this.Height), Color1, Color2);
			Rectangle rect = new Rectangle(0, 0, this.Width, this.Height);
			// Fill with gradient 
			e.Graphics.FillRectangle(GBrush, rect);

			// draw text on label
			SolidBrush drawBrush = new SolidBrush(this.ForeColor);
			StringFormat sf = new StringFormat();
			
			sf.Alignment = StringAlignment.Near;
			sf.Trimming = StringTrimming.EllipsisCharacter;

			// set rectangle bound text
			RectangleF rectF = new RectangleF(0, this.Height / 2 - Font.Height / 2, this.Width, this.Height);
			// output string
			e.Graphics.DrawString(this.Text, this.Font, drawBrush, rectF, sf);

		}
	}
}
